/* file "main.cpp" */

#include <assert.h>

#include "vector3.h"
#include "versor3.h"
#include "point3.h"
#include "mat3.h"
#include "quaternion.h"
#include "shapes.h"
#include "transform.h"
#include "scene.h"

#include "conio.h"

using namespace VgMath;




Scene s;

void applyCommand( int command, GameObject& obj){
    Transform t;

    switch (command) {
    case 'w': t.translate = Vector3(0,0, +0.3); break;
    case 's': t.translate = Vector3(0,0, -0.3); break;
    case 'A': t.translate = Vector3(-0.3,0,0); break; // strafe sx
    case 'D': t.translate = Vector3(+0.3,0,0); break; // strafe dx
    case 'a': t.rotate = Quaternion::angleAxis(  2, Versor3::up() ); break;
    case 'd': t.rotate = Quaternion::angleAxis( -2, Versor3::up() ); break;
    case 'r': t.rotate = Quaternion::angleAxis(  2, Versor3::right() ); break;
    case 'f': t.rotate = Quaternion::angleAxis( -2, Versor3::right() ); break;
    }


    obj.transform = obj.transform * t; // apply transform in LOCAL SPACE

    //obj.transform = t * obj.transform; // apply transform in WORLD SPACE

}

// super ugly hack! Given a character, returns the number under that symbol on the keyboard
int shiftCharToNumber(char c){
    switch (c) {
    case '!' : return 1;
    case '@' : return 2;
    case '#' : return 3;
    case '$' : return 4;
    case '%' : return 5;
    case '^' : return 6;
    case '&' : return 7;
    case '*' : return 8;
    case '(' : return 9;
    case ')' : return 0;
    }
    return -1;
}
int main()
{
    s.createRandom(10);

    int controlledPlayer = 2;
    int viewingPlayer = 2;

    while (1) {

        s.raytrace1stPerson( viewingPlayer );
        //s.raytraceExternalView();

        int c = getch();

        // keys from 0 to 9 change the controlled player
        if ((c>='0') && (c<='9')) viewingPlayer = controlledPlayer = c-'0';

        int t = shiftCharToNumber(c);
        if (t>=0) viewingPlayer = t;

        applyCommand( c, s.object[ controlledPlayer ] );
        if (c=='q') break;

    }

    return 0;
}
